package com.eneraptor.hci

class ErptrTagLib { 

	static namespace = 'erptr'
	def mainMenuService
	
	def menu = { attrs ->
	
		List menuItems = mainMenuService.getMainMenu()
		
		menuItems.each {
			out << "<li"
			if(attrs.chosen == it.name) {
				out << " class='current'"
			}
			out << "><a href='"
			out << g.createLink(controller: "${it.name}", action: "${it.url}")
			out << "'>${it.label}</a></li>"
		}
		
		out << "<li style='float:right;'><a href='"
		out << g.createLink(controller: 'login', action: 'logout')
		out << "'>Log out</a></li>"
			
	}
	
	def subMenu = { attrs ->
		
		List subMenuItems = mainMenuService.getSubMenu(attrs.menu)
		if(subMenuItems == null) {
			out << "<p>This sub-menu is not configured yet.</p>"
		} else {
			subMenuItems.each {
				out << "<li><a href='"
				out << g.createLink(controller: "${it.name}", action: "${it.url}")
				out << "' class='"
				out << "${it.name}-${it.url}"
				out << "'>"
				if(attrs.chosen == it.url) out << "<u>"
				out << it.label
				if(attrs.chosen == it.url) out << "</u>"
				out << "</a></li>"
			}
		}
		
	}
	
	def box = { attrs, body ->
	
		out << "<div class='box'>"
		out << "<h3>${attrs['title']}</h3>"
		out << "<div class='boxContents'>"
		out << body()
		out << "</div>"
		out << "</div>"
		out << "<br />"
			
	}
	
	def helpImg = {
		out << "<img style='position: relative; top: 3px;' src='" + g.resource(dir: 'img/icons/', file:'help.png') + "' />"
	}
	
	def helpBox = {
		out << "<div id='helpBox'>"
		out << "</div><br />"
	}
	
	def confirmBox = { attrs, body ->
		out << "<div id='confirmBox'>"
		out << "<div class='confirmBoxContent'>"
		out << "<img style='float: left;margin:5px;position:relative;top:-2px;' src='" + g.resource(dir: 'img/icons/', file:'tick.png') + "' />"
		out << body()
		out << "</div>"
		out << "</div><br />"
	}
	
	def errorBox = { attrs, body ->
		out << "<div id='errorBox'>"
		out << "<div class='errorBoxContent'>"
		out << "<img style='float: left;margin:5px;position:relative;top:-2px;' src='" + g.resource(dir: 'img/icons/', file:'cross.png') + "' />"
		out << body()
		out << "</div>"
		out << "</div><br />"
	}
	
	def warningBox = { attrs, body ->
		out << "<div id='warningBox'>"
		out << "<div class='warningBoxContent'>"
		out << "<img style='float: left;margin:5px;position:relative;top:-2px;' src='" + g.resource(dir: 'img/icons/', file:'error.png') + "' />"
		out << body()
		out << "</div>"
		out << "</div><br />"
	}
	
	def logEntryOptions = { attrs ->
		out << "<a href='"
		out << g.createLink(action: 'detail', id: attrs.for)
		out << "'>"
		out << "<img src='"
		out << g.resource(dir: 'img/icons/', file: 'information.png')
		out << "' />"
		out << "</a>"
		out << "<a href='"
		out << g.createLink(action: 'deleteEntry', id: attrs.for)
		out << "'>"
		out << "<img src='"
		out << g.resource(dir: 'img/icons/', file: 'delete.png')
		out << "' />"
		out << "</a>"
	}
	
	def changeDeleteOptions = { attrs ->
		out << "<a href='"
		out << g.createLink(action: 'change' + attrs.table + 'Entry', id: attrs.for)
		out << "'>"
		out << "<img src='"
		out << g.resource(dir: 'img/icons/', file: 'wrench_orange.png')
		out << "' />"
		out << "</a>"
		out << "<a href='"
		out << g.createLink(action: 'delete' + attrs.table + 'Entry', id: attrs.for)
		out << "'>"
		out << "<img src='"
		out << g.resource(dir: 'img/icons/', file: 'delete.png')
		out << "' />"
		out << "</a>"
	}
	
	def icon = { attrs ->
		out << "<img style='float:left;position:relative;bottom:2px;' src='"
		out << g.resource(dir: "img/icons/", file: attrs.w + ".png")
		out << "' />"
	}
	
	def helpLink = { attrs ->
		
		out << g.remoteLink(action:"getHelp", params: [what: attrs.for], update: "helpBox", after: "\$('helpBox').pulsate({pulses: 2, duration: 0.5, from: 0.5})", erptr.helpImg())
		
	}
	
	def rawInfoBox = { attrs, body ->
		out << "<div class='rawInfoBox'>"
		out << body()
		out << "</div>"
	}
	
}
